diff -ruN asterisk-1.2.12-orig/Makefile asterisk-1.2.12/Makefile
--- asterisk-1.2.12-orig/Makefile	2006-09-06 16:09:10.000000000 -0400
+++ asterisk-1.2.12/Makefile	2006-09-09 16:55:48.000000000 -0400
@@ -827,7 +827,7 @@
 	@echo " +-------------------------------------------+"  
 
 spec: 
-	sed "s/^Version:.*/Version: $(RPMVERSION)/g" redhat/asterisk.spec > asterisk.spec ; \
+	sed "s/^Version:.*/Version: $(RPMVERSION)/g" redhat/asterisk.spec.in > asterisk.spec ; \
 
 rpm: __rpm
 
diff -ruN asterisk-1.2.12-orig/redhat/asterisk.spec asterisk-1.2.12/redhat/asterisk.spec
--- asterisk-1.2.12-orig/redhat/asterisk.spec	2006-05-03 14:31:20.000000000 -0400
+++ asterisk-1.2.12/redhat/asterisk.spec	1969-12-31 19:00:00.000000000 -0500
@@ -1,135 +0,0 @@
-Summary: Asterisk PBX
-Name: asterisk
-Distribution: RedHat
-Version: CVS
-Release: 1
-Copyright: Linux Support Services, inc.
-Group: Utilities/System
-Vendor: Linux Support Services, inc.
-Packager: Robert Vojta <vojta@ipex.cz>
-BuildRoot: /tmp/asterisk
-
-%description
-Asterisk is an Open Source PBX and telephony development platform that
-can both replace a conventional PBX and act as a platform for developing
-custom telephony applications for delivering dynamic content over a
-telephone similarly to how one can deliver dynamic content through a
-web browser using CGI and a web server.
-
-Asterisk talks to a variety of telephony hardware including BRI, PRI, 
-POTS, and IP telephony clients using the Inter-Asterisk eXchange
-protocol (e.g. gnophone or miniphone).  For more information and a
-current list of supported hardware, see www.asteriskpbx.com.
-
-%package        devel
-Summary:        Header files for building Asterisk modules
-Group:          Development/Libraries
-
-%description devel
-This package contains the development  header files that are needed
-to compile 3rd party modules.
-
-%post
-ln -sf /var/spool/asterisk/vm /var/lib/asterisk/sounds/vm
-
-%files
-#
-# Configuration files
-#
-%attr(0755,root,root) %dir    /etc/asterisk
-%config(noreplace) %attr(0640,root,root) /etc/asterisk/*.conf
-%config(noreplace) %attr(0640,root,root) /etc/asterisk/*.adsi
-%config(noreplace) %attr(0640,root,root) /etc/asterisk/extensions.ael
-
-#
-# RedHat specific init script file
-#
-%attr(0755,root,root)       /etc/rc.d/init.d/asterisk
-
-#
-# Modules
-#
-%attr(0755,root,root) %dir /usr/lib/asterisk
-%attr(0755,root,root) %dir /usr/lib/asterisk/modules
-%attr(0755,root,root)      /usr/lib/asterisk/modules/*.so
-
-#
-# Asterisk
-#
-%attr(0755,root,root)      /usr/sbin/asterisk
-%attr(0755,root,root)      /usr/sbin/safe_asterisk
-%attr(0755,root,root)      /usr/sbin/astgenkey
-%attr(0755,root,root)      /usr/sbin/astman
-%attr(0755,root,root)      /usr/sbin/autosupport
-%attr(0755,root,root)      /usr/sbin/smsq
-%attr(0755,root,root)      /usr/sbin/stereorize
-%attr(0755,root,root)      /usr/sbin/streamplayer
-
-#
-# CDR Locations
-#
-%attr(0755,root,root) %dir /var/log/asterisk
-%attr(0755,root,root) %dir /var/log/asterisk/cdr-csv
-#
-# Running directories
-#
-%attr(0755,root,root) %dir /var/run
-#
-# Sound files
-#
-%attr(0755,root,root) %dir /var/lib/asterisk
-%attr(0755,root,root) %dir /var/lib/asterisk/sounds
-%attr(0644,root,root)      /var/lib/asterisk/sounds/*.gsm
-%attr(0755,root,root) %dir /var/lib/asterisk/sounds/dictate
-%attr(0644,root,root)      /var/lib/asterisk/sounds/dictate/*.gsm
-%attr(0755,root,root) %dir /var/lib/asterisk/sounds/digits
-%attr(0644,root,root)      /var/lib/asterisk/sounds/digits/*.gsm
-%attr(0755,root,root) %dir /var/lib/asterisk/sounds/letters
-%attr(0644,root,root)      /var/lib/asterisk/sounds/letters/*.gsm
-%attr(0755,root,root) %dir /var/lib/asterisk/sounds/phonetic
-%attr(0644,root,root)      /var/lib/asterisk/sounds/phonetic/*.gsm
-%attr(0755,root,root) %dir /var/lib/asterisk/mohmp3
-%attr(0644,root,root)      /var/lib/asterisk/mohmp3/*
-%attr(0755,root,root) %dir /var/lib/asterisk/images
-%attr(0644,root,root)      /var/lib/asterisk/images/*
-%attr(0755,root,root) %dir /var/lib/asterisk/keys
-%attr(0644,root,root)      /var/lib/asterisk/keys/*
-%attr(0755,root,root) %dir /var/lib/asterisk/agi-bin
-%attr(0755,root,root) %dir /var/lib/asterisk/agi-bin/*
-#
-# Man page
-#
-%attr(0644,root,root)      /usr/share/man/man8/asterisk.8
-%attr(0644,root,root)      /usr/share/man/man8/astgenkey.8
-%attr(0644,root,root)      /usr/share/man/man8/autosupport.8
-%attr(0644,root,root)      /usr/share/man/man8/safe_asterisk.8
-
-#
-# Firmware
-#
-%attr(0755,root,root) %dir /var/lib/asterisk/firmware
-%attr(0755,root,root) %dir /var/lib/asterisk/firmware/iax
-%attr(0755,root,root)      /var/lib/asterisk/firmware/iax/*.bin
-
-#
-# Example voicemail files
-#
-%attr(0755,root,root) %dir /var/spool/asterisk
-%attr(0755,root,root) %dir /var/spool/asterisk/voicemail
-%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default
-%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default/1234
-%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default/1234/INBOX
-%attr(0644,root,root)      /var/spool/asterisk/voicemail/default/1234/*.gsm
-
-#
-# Misc other spool
-#
-%attr(0755,root,root) %dir /var/spool/asterisk/system
-%attr(0755,root,root) %dir /var/spool/asterisk/tmp
-
-%files devel
-#
-# Include files
-#
-%attr(0755,root,root) %dir %{_includedir}/asterisk
-%attr(0644,root,root) %{_includedir}/asterisk/*.h
diff -ruN asterisk-1.2.12-orig/redhat/asterisk.spec.in asterisk-1.2.12/redhat/asterisk.spec.in
--- asterisk-1.2.12-orig/redhat/asterisk.spec.in	1969-12-31 19:00:00.000000000 -0500
+++ asterisk-1.2.12/redhat/asterisk.spec.in	2006-09-09 16:56:09.000000000 -0400
@@ -0,0 +1,159 @@
+%ifarch i686
+%define K60PT K60PT=-DK60PT
+%else
+%define K60PT K60PT=''
+%endif
+
+Summary: Asterisk PBX
+Name: asterisk
+Distribution: RedHat
+Version: CVS
+Release: 1
+License: GPL
+URL: http://www.asterisk.org
+Group: Utilities/System
+Vendor: Linux Support Services, inc.
+Packager: Robert Vojta <vojta@ipex.cz>
+BuildRoot: /tmp/%{name}-%{version}-root
+Source0: %{name}-%{version}.tar.gz
+
+%description
+Asterisk is an Open Source PBX and telephony development platform that
+can both replace a conventional PBX and act as a platform for developing
+custom telephony applications for delivering dynamic content over a
+telephone similarly to how one can deliver dynamic content through a
+web browser using CGI and a web server.
+
+Asterisk talks to a variety of telephony hardware including BRI, PRI, 
+POTS, and IP telephony clients using the Inter-Asterisk eXchange
+protocol (e.g. gnophone or miniphone).  For more information and a
+current list of supported hardware, see www.asteriskpbx.com.
+
+%package        devel
+Summary:        Header files for building Asterisk modules
+Group:          Development/Libraries
+
+%description devel
+This package contains the development  header files that are needed
+to compile 3rd party modules.
+
+%prep
+%setup
+
+%build
+make clean
+make %{K60PT} all
+
+%install
+rm -rf %{buildroot}
+make DESTDIR=%{buildroot} %{K60PT} install
+make DESTDIR=%{buildroot} %{K60PT} samples
+mkdir -p %{buildroot}/etc/rc.d/init.d
+cp -f contrib/init.d/rc.redhat.asterisk %{buildroot}/etc/rc.d/init.d/asterisk
+
+
+%post
+ln -sf /var/spool/asterisk/vm /var/lib/asterisk/sounds/vm
+
+%files
+#
+# Configuration files
+#
+%attr(0755,root,root) %dir    /etc/asterisk
+%config(noreplace) %attr(0640,root,root) /etc/asterisk/*.conf
+%config(noreplace) %attr(0640,root,root) /etc/asterisk/*.adsi
+%config(noreplace) %attr(0640,root,root) /etc/asterisk/extensions.ael
+
+#
+# RedHat specific init script file
+#
+%attr(0755,root,root)       /etc/rc.d/init.d/asterisk
+
+#
+# Modules
+#
+%attr(0755,root,root) %dir /usr/lib/asterisk
+%attr(0755,root,root) %dir /usr/lib/asterisk/modules
+%attr(0755,root,root)      /usr/lib/asterisk/modules/*.so
+
+#
+# Asterisk
+#
+%attr(0755,root,root)      /usr/sbin/asterisk
+%attr(0755,root,root)      /usr/sbin/safe_asterisk
+%attr(0755,root,root)      /usr/sbin/astgenkey
+%attr(0755,root,root)      /usr/sbin/astman
+%attr(0755,root,root)      /usr/sbin/autosupport
+%attr(0755,root,root)      /usr/sbin/rasterisk
+%attr(0755,root,root)      /usr/sbin/smsq
+%attr(0755,root,root)      /usr/sbin/stereorize
+%attr(0755,root,root)      /usr/sbin/streamplayer
+
+#
+# CDR Locations
+#
+%attr(0755,root,root) %dir /var/log/asterisk
+%attr(0755,root,root) %dir /var/log/asterisk/cdr-csv
+#
+# Running directories
+#
+%attr(0755,root,root) %dir /var/run
+#
+# Sound files
+#
+%attr(0755,root,root) %dir /var/lib/asterisk
+%attr(0755,root,root) %dir /var/lib/asterisk/sounds
+%attr(0644,root,root)      /var/lib/asterisk/sounds/*.gsm
+%attr(0755,root,root) %dir /var/lib/asterisk/sounds/dictate
+%attr(0644,root,root)      /var/lib/asterisk/sounds/dictate/*.gsm
+%attr(0755,root,root) %dir /var/lib/asterisk/sounds/digits
+%attr(0644,root,root)      /var/lib/asterisk/sounds/digits/*.gsm
+%attr(0755,root,root) %dir /var/lib/asterisk/sounds/letters
+%attr(0644,root,root)      /var/lib/asterisk/sounds/letters/*.gsm
+%attr(0755,root,root) %dir /var/lib/asterisk/sounds/phonetic
+%attr(0644,root,root)      /var/lib/asterisk/sounds/phonetic/*.gsm
+%attr(0755,root,root) %dir /var/lib/asterisk/mohmp3
+%attr(0644,root,root)      /var/lib/asterisk/mohmp3/*
+%attr(0755,root,root) %dir /var/lib/asterisk/images
+%attr(0644,root,root)      /var/lib/asterisk/images/*
+%attr(0755,root,root) %dir /var/lib/asterisk/keys
+%attr(0644,root,root)      /var/lib/asterisk/keys/*
+%attr(0755,root,root) %dir /var/lib/asterisk/agi-bin
+%attr(0755,root,root) %dir /var/lib/asterisk/agi-bin/*
+#
+# Man page
+#
+%attr(0644,root,root)      /usr/share/man/man8/asterisk.8.gz
+%attr(0644,root,root)      /usr/share/man/man8/astgenkey.8.gz
+%attr(0644,root,root)      /usr/share/man/man8/autosupport.8.gz
+%attr(0644,root,root)      /usr/share/man/man8/safe_asterisk.8.gz
+
+#
+# Firmware
+#
+%attr(0755,root,root) %dir /var/lib/asterisk/firmware
+%attr(0755,root,root) %dir /var/lib/asterisk/firmware/iax
+%attr(0755,root,root)      /var/lib/asterisk/firmware/iax/*.bin
+
+#
+# Example voicemail files
+#
+%attr(0755,root,root) %dir /var/spool/asterisk
+%attr(0755,root,root) %dir /var/spool/asterisk/voicemail
+%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default
+%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default/1234
+%attr(0755,root,root) %dir /var/spool/asterisk/voicemail/default/1234/INBOX
+%attr(0644,root,root)      /var/spool/asterisk/voicemail/default/1234/*.gsm
+
+#
+# Misc other spool
+#
+%attr(0755,root,root) %dir /var/spool/asterisk/system
+%attr(0755,root,root) %dir /var/spool/asterisk/tmp
+
+%files devel
+#
+# Include files
+#
+%attr(0755,root,root) %dir %{_includedir}/asterisk
+%attr(0644,root,root) %{_includedir}/asterisk/*.h